VERSION 5.00
Begin VB.Form IcoMenu 
   BorderStyle     =   3  'Fixed Dialog
   ClientHeight    =   4710
   ClientLeft      =   45
   ClientTop       =   45
   ClientWidth     =   4950
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4710
   ScaleWidth      =   4950
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin VB.Image IMenu 
      Height          =   240
      Index           =   0
      Left            =   0
      Picture         =   "IcoMenu.frx":0000
      Top             =   0
      Width           =   240
   End
   Begin VB.Label LBLtop 
      Height          =   60
      Index           =   0
      Left            =   2400
      TabIndex        =   1
      Top             =   240
      Width           =   1455
   End
   Begin VB.Label LBLmenu 
      AutoSize        =   -1  'True
      Caption         =   "IcoMenu by FredJust"
      Height          =   195
      Index           =   0
      Left            =   300
      TabIndex        =   0
      Top             =   0
      Width           =   1485
   End
   Begin VB.Label LBLleftUp 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "c"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   14.25
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000014&
      Height          =   285
      Left            =   0
      TabIndex        =   3
      Top             =   0
      Visible         =   0   'False
      Width           =   285
   End
   Begin VB.Label LBLrightDown 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "d"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   14.25
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000010&
      Height          =   285
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Visible         =   0   'False
      Width           =   285
   End
   Begin VB.Line LineUP 
      BorderColor     =   &H80000010&
      Index           =   0
      Visible         =   0   'False
      X1              =   15
      X2              =   2760
      Y1              =   1080
      Y2              =   1080
   End
   Begin VB.Line LineDown 
      BorderColor     =   &H80000014&
      Index           =   0
      Visible         =   0   'False
      X1              =   15
      X2              =   2760
      Y1              =   1095
      Y2              =   1095
   End
End
Attribute VB_Name = "IcoMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'===============================================================================
'   FredJust IcoMenu Form !
'   http://fred.just.free.fr/
'   fred.just@free.fr
'
'   PERFECT IMITATION OF A WINDOWS MENU WITH ICONS
'
'===============================================================================

Option Explicit

Public LastMenu As Long                                    ' Used for Switch Off Item
Private MaxWidth As Long                                   ' Used for Calcule the Form Width
Private FormHeight As Long                                 ' Used for calcule the From Height
Private NbMenu As Long                                     ' Number of item in menu (19 pixel height)
Private NbSeparator As Long                                ' Number of separator in menu (10 pixel height)


Const MenuHeight = 285                                     ' Change only if you want another effect (19 pixel height=19*15 TWIPS)
Const LBLtopHeight = 60                                    ' Label apear on bottom

Public NbSpaceAfterCaption As Long                         ' Nb Space after each caption

Public ForeColorOver As Long                               ' you can custimize this 2 color !
Public BackColorOver As Long


' events which can be raised
Public Event Click(ByVal index As Long, Tag As String)
Public Event Closed()
Public Event MouseDown(ByVal index As Long, Tag As String, Button As Integer, Shift As Integer)
Public Event MouseUp(ByVal index As Long, Tag As String, Button As Integer, Shift As Integer)
Public Event MouseMove(ByVal index As Long, Tag As String)

'   THIS API IS USE FOR SHOWING MENU ON CURSOR POSITION
Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

'===============================================================================
'   Add or Set an item to the menu
'===============================================================================
Public Sub AddItem(ByVal Caption As String, _
        Optional Icon As IPictureDisp, _
        Optional Key As String)

    On Error Resume Next

    '   add a separator line
    If Caption = "-" Then

        Load LineDown(NbSeparator)
        Load LineUP(NbSeparator)

        LineUP(NbSeparator).Y1 = FormHeight + 60
        LineUP(NbSeparator).Y2 = FormHeight + 60

        LineDown(NbSeparator).Y1 = LineUP(NbSeparator).Y1 + 15
        LineDown(NbSeparator).Y2 = LineUP(NbSeparator).Y2 + 15

        LineUP(NbSeparator).Visible = True
        LineDown(NbSeparator).Visible = True

        FormHeight = FormHeight + 150
        NbSeparator = NbSeparator + 1

    Else                                                   '   add Menu item

        Load LBLmenu(NbMenu)
        Load IMenu(NbMenu)
        Load LBLtop(NbMenu)

        SetItem NbMenu, Caption, Icon

        With LBLmenu(NbMenu)
            .Tag = Key
            .Top = FormHeight + LBLtopHeight
            .Visible = True
        End With

        With LBLtop(NbMenu)
            .Top = FormHeight
            .Visible = True
        End With

        With IMenu(NbMenu)
            .Top = FormHeight + 15
            .Left = 15
            .Visible = True
        End With

        NbMenu = NbMenu + 1

        FormHeight = FormHeight + 285

        LastMenu = LBLmenu.UBound
    End If

End Sub


'==================================================================================
'
'==================================================================================
Public Sub SetItem(ByVal index As Long, ByVal Caption As String, _
        Optional Icon As IPictureDisp, _
        Optional Key As String)

    If Icon Is Nothing Then
        Set IMenu(index).Picture = Nothing
        LBLmenu(index).Caption = Space(7) & Caption & Space(NbSpaceAfterCaption)
        LBLmenu(index).Left = 0
        LBLtop(index).Left = 0
        If LBLmenu(index).Width > MaxWidth Then MaxWidth = LBLmenu(index).Width
    Else
        Set IMenu(index).Picture = Icon
        LBLmenu(index).Caption = " " & Caption & Space(NbSpaceAfterCaption)
        LBLmenu(index).Left = 300
        LBLtop(index).Left = 300
        If LBLmenu(index).Width + 300 > MaxWidth Then MaxWidth = LBLmenu(index).Width + 300
    End If

    IMenu(index).ZOrder

End Sub

'===============================================================================
'
'===============================================================================
Public Sub DestroyMenu()
    Unload Me
End Sub

'===============================================================================
'
'===============================================================================
Public Sub ShowMenu(Optional ByVal Left As Long = -1, Optional ByVal Top As Long = -1)
    Dim i As Long
    Dim CurPos As POINTAPI

    Me.Height = FormHeight + 90

    If Left = -1 Then
        GetCursorPos CurPos
        Me.Left = CurPos.X * Screen.TwipsPerPixelX
        Me.Top = CurPos.Y * Screen.TwipsPerPixelY
    Else
        Me.Left = Left
        Me.Top = Top
    End If

    For i = LBLmenu.LBound To LBLmenu.UBound
        With LBLmenu(i)
            .AutoSize = False
            .Width = MaxWidth
            .Height = MenuHeight - LBLtopHeight
        End With
        LBLtop(i).Width = LBLmenu(i).Width
    Next

    Me.Width = MaxWidth + 90
    'Me.Show
    ShowOn Me.hwnd, True
End Sub

'===============================================================================
'   HIDE MENU AND HIDE SELECT ITEM
'===============================================================================
Public Sub HideMenu()
    Me.Hide
    LBLmenu(LastMenu).BackColor = Me.BackColor
    LBLmenu(LastMenu).ForeColor = Me.ForeColor
    LBLtop(LastMenu).BackColor = Me.BackColor
    LBLleftUp.Visible = False
    LBLrightDown.Visible = False
    LastMenu = LBLmenu.UBound
    RaiseEvent Closed
End Sub

'===============================================================================
'
'===============================================================================
Private Sub Form_Initialize()
    LastMenu = 0
    MaxWidth = 90
    BackColorOver = vbHighlight
    ForeColorOver = vbHighlightText
    NbSpaceAfterCaption = 5
    NbMenu = 0
    NbSeparator = 0
    FormHeight = 0
End Sub

'===============================================================================
'   HIDE MENU IF THE FORM LOST THE FOCUS
'===============================================================================
Private Sub Form_LostFocus()
    HideMenu
End Sub

'===============================================================================
'   RESIZE SEPARATOR LINES
'===============================================================================
Private Sub Form_Resize()
    Dim i As Long
    For i = LineUP.LBound To LineUP.UBound
        LineUP(i).X2 = Me.ScaleWidth - 30
        LineDown(i).X2 = Me.ScaleWidth - 30
    Next i
End Sub

'===============================================================================
'
'===============================================================================
Private Sub IMenu_Click(index As Integer)
    Call LBLmenu_Click(index)
End Sub

'===============================================================================
'
'===============================================================================
Private Sub IMenu_MouseMove(index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Call LBLmenu_MouseMove(index, Button, Shift, X, Y)
End Sub

'===============================================================================
'
'===============================================================================
Private Sub LBLmenu_Click(index As Integer)
    Me.Hide
    RaiseEvent Click(index, LBLmenu(index).Tag)
End Sub

'===============================================================================
'
'===============================================================================
Private Sub LBLmenu_MouseDown(index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(index, LBLmenu(index).Tag, Button, Shift)
End Sub

Private Sub LBLmenu_MouseUp(index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(index, LBLmenu(index).Tag, Button, Shift)
End Sub
'===============================================================================
'
'===============================================================================
Private Sub LBLmenu_MouseMove(index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

    If LastMenu = index Then Exit Sub

    RaiseEvent MouseMove(index, LBLmenu(index).Tag)

    LBLmenu(LastMenu).BackColor = Me.BackColor
    LBLmenu(LastMenu).ForeColor = Me.ForeColor
    LBLtop(LastMenu).BackColor = Me.BackColor

    LBLmenu(index).BackColor = BackColorOver
    LBLmenu(index).ForeColor = ForeColorOver
    LBLtop(index).BackColor = BackColorOver


    If LBLmenu(index).Left = 0 Then
        LBLleftUp.Visible = False
        LBLrightDown.Visible = False
    Else
        LBLleftUp.Visible = True
        LBLleftUp.Top = LBLmenu(index).Top - 60
        LBLrightDown.Visible = True
        LBLrightDown.Top = LBLmenu(index).Top - 60
    End If

    LastMenu = index
End Sub

'===============================================================================
'
'===============================================================================
Private Sub LBLtop_MouseDown(index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(index, LBLmenu(index).Tag, Button, Shift)
End Sub

Private Sub LBLtop_Click(index As Integer)
    Call LBLmenu_Click(index)
End Sub

Private Sub LBLtop_MouseMove(index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Call LBLmenu_MouseMove(index, Button, Shift, X, Y)
End Sub

Private Sub LBLtop_MouseUp(index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(index, LBLmenu(index).Tag, Button, Shift)
End Sub
