VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "class_Connect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IDTExtensibility

Public FormDisplayed    As Boolean
Dim mcbMenuCommandBar   As Office.CommandBarControl
Private cbMonMenu       As Office.CommandBarButton

Public WithEvents MenuHandler As CommandBarEvents          'command bar event handler
Attribute MenuHandler.VB_VarHelpID = -1


'===============================================================================
'
'===============================================================================
Private Sub IDTExtensibility_OnAddInsUpdate(custom() As Variant)
    ' **********************************************************************

End Sub

'===============================================================================
'
'===============================================================================
Private Sub IDTExtensibility_OnConnection(ByVal VBInst As Object, ByVal ConnectMode As vbext_ConnectMode, ByVal AddInInst As VBIDE.AddIn, custom() As Variant)
    On Error GoTo gestion_erreur
    'on stocke la rfrence  l'environnement de VB
    Set VBInstance = VBInst

    'appel par la barre de gestion des complments
    If ConnectMode = ext_cm_External Then
        objWindowProgrammez.Visible = True
    Else                                                   'sinon on ajoute le bouton
        frmTodo.Show
        SetupCommandbar
    End If

    Exit Sub
gestion_erreur:
    MsgBox Err.Description, vbCritical, "ERREUR n" & CStr(Err.Number) & " in IDTExtensibility_OnConnection"
End Sub

'===============================================================================
'
'===============================================================================
Private Sub IDTExtensibility_OnDisconnection(ByVal RemoveMode As vbext_DisconnectMode, custom() As Variant)
    On Error Resume Next

    'suppression du bouton
    If cbMonMenu Is Nothing Then MsgBox "Le bouton n'existe plus !" Else cbMonMenu.Delete

    'on fait le mnage
    Unload IcoMenu
    Unload frmTodo
    Set cbMonMenu = Nothing
    Set objWindowProgrammez = Nothing
    Set VBInstance = Nothing

End Sub

'===============================================================================
'
'===============================================================================
Private Sub IDTExtensibility_OnStartupComplete(custom() As Variant)
    ' **********************************************************************

End Sub

'===============================================================================
'
'===============================================================================
Private Sub MenuHandler_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    frmTodo.Show
End Sub

'===============================================================================
'
'===============================================================================
Function AddToAddInCommandBar(sCaption As String) As Office.CommandBarControl
    Dim cbMenuCommandBar As Office.CommandBarControl       'command bar object
    Dim cbMenu           As Object

    On Error GoTo AddToAddInCommandBarErr

    'see if we can find the Add-Ins menu
    Set cbMenu = VBInstance.CommandBars("Add-Ins")
    If cbMenu Is Nothing Then
        'not available so we fail
        Exit Function
    End If

    'add it to the command bar
    Set cbMenuCommandBar = cbMenu.Controls.Add(1)
    'set the caption
    cbMenuCommandBar.Caption = sCaption

    Set AddToAddInCommandBar = cbMenuCommandBar

    Exit Function

AddToAddInCommandBarErr:

End Function

'===============================================================================
'
'===============================================================================
Private Function SetupCommandbar() As Boolean
    Dim cbMenu As Office.CommandBarControl                 'le menu Complments de VB

    On Error GoTo GestErr
    SetupCommandbar = True                                 'on suppose que tout marche bien
    Set cbMenu = VBInstance.CommandBars(1).Controls(11)

    If cbMenu Is Nothing Then GoTo GestErr

    Set cbMonMenu = cbMenu.Controls.Add                    'ajout du bouton
    cbMonMenu.Caption = "Liste des Tches et des Signets."

    'on copie dans le presse papier l'icne
    Clipboard.SetData LoadResPicture(101, vbResBitmap)
    'on l'ajoute  notre bouton
    cbMonMenu.PasteFace
    'capture de l'vnement
    Set Me.MenuHandler = VBInstance.Events.CommandBarEvents(cbMonMenu)

    Exit Function
GestErr:
    SetupCommandbar = False
End Function

