VERSION 5.00
Begin VB.Form IcoMenu 
   BorderStyle     =   3  'Fixed Dialog
   ClientHeight    =   1560
   ClientLeft      =   45
   ClientTop       =   45
   ClientWidth     =   3075
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   Icon            =   "IcoMenu.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1560
   ScaleWidth      =   3075
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin VB.Image IMenu 
      Height          =   240
      Index           =   0
      Left            =   30
      Picture         =   "IcoMenu.frx":014A
      Top             =   30
      Width           =   240
   End
   Begin VB.Label LBLmenu 
      AutoSize        =   -1  'True
      Caption         =   "IcoMenu by FredJust"
      Height          =   195
      Index           =   0
      Left            =   300
      TabIndex        =   0
      Top             =   0
      Width           =   1485
   End
   Begin VB.Image IMup 
      Height          =   285
      Left            =   0
      Picture         =   "IcoMenu.frx":0294
      Top             =   0
      Width           =   285
   End
End
Attribute VB_Name = "IcoMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'   FredJust IcoMenu Form !
'   http://fred.just.free.fr/
'   fred.just@free.fr

Option Explicit

Private LastIco         As Long    ' Used for Switch Off Item
Private MaxWidth        As Long    ' Used for Calcule the Form Width

Const MenuHeight = 285    ' Change only i tou want another effect

Public NbSpaceAfterCaption As Long    ' Nb Space after each caption

Public ForeColorOver    As Long    ' you can custimize this 2 color !
Public BackColorOver    As Long

' events which can be raised
Public Event Click(ByVal Index As Long, Tag As String)
Public Event Closed()
Public Event MouseDown(ByVal Index As Long, Tag As String, Button As Integer, Shift As Integer)
Public Event MouseUp(ByVal Index As Long, Tag As String, Button As Integer, Shift As Integer)
Public Event MouseMove(ByVal Index As Long, Tag As String)

Private Type POINTAPI
    X                    As Long
    Y                    As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

'   Add or Set an item to the menu

Public Sub SetItem(ByVal Index As Long, ByVal Caption As String, _
   Optional Icon As IPictureDisp, _
   Optional Key As String) ', _
                                   'Optional BackColorOver As Long, _ it's possible to imagine more effect
    'Optional ForeColorOver As Long) ... Saved in the tag for example

    On Error Resume Next    'error apear in the 2 next line if the load was made left
    Load LBLmenu(Index)
    Load IMenu(Index)

    If Icon Is Nothing Then
        LBLmenu(Index).Caption = Space(7) & Caption & Space(NbSpaceAfterCaption)
        LBLmenu(Index).Left = 15
        If LBLmenu(Index).Width > MaxWidth Then MaxWidth = LBLmenu(Index).Width
    Else
        Set IMenu(Index).Picture = Icon
        LBLmenu(Index).Caption = " " & Caption & Space(NbSpaceAfterCaption)
        LBLmenu(Index).Left = 300
        If LBLmenu(Index).Width + 300 > MaxWidth Then MaxWidth = LBLmenu(Index).Width + 300
    End If

    With LBLmenu(Index)
        .Tag = Key
        .Top = MenuHeight * Index
        .Visible = True
    End With

    With IMenu(Index)
        .Top = MenuHeight * Index + 15
        .Left = 15
        .Visible = True
    End With

    LastIco = LBLmenu.UBound

End Sub

'

Public Sub DestroyMenu()
Attribute DestroyMenu.VB_UserMemId = 1610809345
    Unload Me
End Sub

'

Public Sub ShowMenu(Optional ByVal Left As Long = -1, Optional ByVal Top As Long = -1)
Attribute ShowMenu.VB_UserMemId = 1610809346
    Dim i                As Long
    Dim CurPos           As POINTAPI
    Me.Height = MenuHeight * LBLmenu.Count + 90

    If Left = -1 Then
        GetCursorPos CurPos
        Me.Left = CurPos.X * Screen.TwipsPerPixelX
        Me.Top = CurPos.Y * Screen.TwipsPerPixelY
    Else
        Me.Left = Left
        Me.Top = Top
    End If

    For i = LBLmenu.LBound To LBLmenu.UBound
        With LBLmenu(i)
            .AutoSize = False
            .Width = MaxWidth
            .Height = MenuHeight
        End With
    Next

    Me.Width = MaxWidth + 90
    Call LBLmenu_MouseMove(0, 0, 0, 0, 0)
    Me.Show
End Sub

'

Public Sub HideMenu()
Attribute HideMenu.VB_UserMemId = 1610809347
    Me.Hide
End Sub

Private Sub Form_Activate()
    IMup.ZOrder 1
End Sub

'

Private Sub Form_Initialize()
    LastIco = 0
    MaxWidth = 90
    BackColorOver = vbHighlight
    ForeColorOver = vbHighlightText
    NbSpaceAfterCaption = 5
End Sub

'

Private Sub Form_LostFocus()
    Me.Hide
    RaiseEvent Closed
End Sub

Private Sub IMenu_Click(Index As Integer)
    Call LBLmenu_Click(Index)
End Sub

Private Sub IMenu_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Call LBLmenu_MouseMove(Index, Button, Shift, X, Y)
End Sub

'

Private Sub LBLmenu_Click(Index As Integer)
    Me.Hide
    RaiseEvent Click(Index, LBLmenu(Index).Tag)
End Sub

'

Private Sub LBLmenu_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Index, LBLmenu(Index).Tag, Button, Shift)
End Sub

'

Private Sub LBLmenu_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

    If LastIco = Index Then Exit Sub

    LBLmenu(LastIco).BackColor = Me.BackColor
    LBLmenu(LastIco).ForeColor = Me.ForeColor
    LBLmenu(Index).BackColor = BackColorOver
    LBLmenu(Index).ForeColor = ForeColorOver

    If LBLmenu(Index).Left = 15 Then
        IMup.Visible = False
    Else
        ' a decoche s'il existe des sans icone
        'IMup.Visible = True
        IMup.Top = MenuHeight * Index

    End If

    LastIco = Index
    RaiseEvent MouseMove(Index, LBLmenu(Index).Tag)
End Sub

'

Private Sub LBLmenu_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Index, LBLmenu(Index).Tag, Button, Shift)
End Sub

