VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Lignes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Lign"
Attribute VB_Ext_KEY = "Member0" ,"Lign"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"

Option Explicit

'variable locale pour la collection
Private mCol            As Collection

Public Sub Add(ByVal ProcName As String, ByVal UpdateDate As Date, _
   ByVal CoderName As String, ByVal ModuleType As Long, ByVal ModuleName As String, _
   ByVal Text As String, ByVal Checked As Boolean, _
   ByVal Icon As Long, ByVal sKey As String, Optional ByVal NumLigne As Long)
Attribute Add.VB_UserMemId = 1610809345

    'crer un nouvel objet
    Dim objNewMember     As Lign
    Set objNewMember = New Lign

    'dfinir les proprits passes  la mthode
    objNewMember.ProcName = ProcName
    objNewMember.UpdateDate = UpdateDate
    objNewMember.CoderName = CoderName
    objNewMember.ModuleType = ModuleType
    objNewMember.ModuleName = ModuleName
    objNewMember.Text = Text
    objNewMember.Checked = Checked
    objNewMember.Key = sKey
    objNewMember.Icon = Icon
    objNewMember.LigneNumber = NumLigne

    mCol.Add objNewMember, sKey

    Set objNewMember = Nothing

End Sub

Public Property Get Item(vntIndexKey As Variant) As Lign
Attribute Item.VB_UserMemId = 0
    'Utilis pour rfrencer un lment dans la collection
    'vntIndexKey contient l'index ou la cl dans la collection
    'Il est donc dclar en tant que Variant
    'Syntaxe: Set toto = x.Item(xyz) ou Set toto = x.Item(5)
    Set Item = mCol(vntIndexKey)
End Property

Public Property Get Count() As Long
Attribute Count.VB_UserMemId = 1745027072
    'utilise pour lire le nombre d'lments dans la
    'collection. Syntaxe: Debug.Print x.Count
    Count = mCol.Count
End Property

Public Sub Remove(vntIndexKey As Variant)
Attribute Remove.VB_UserMemId = 1610809346
    'utilise lors de la suppression d'un lment de la collection
    'vntIndexKey contient l'index ou la cl, il est donc
    'dclar en tant que Variant
    'Syntaxe: x.Remove(xyz)

    mCol.Remove vntIndexKey
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'Cette proprit vous permet d'numrer
    'cette collection avec la syntaxe For...Each
    Set NewEnum = mCol.[_NewEnum]
End Property

Private Sub Class_Initialize()
    'Cre la collection lorsque cette classe est cre
    Set mCol = New Collection
End Sub

Private Sub Class_Terminate()
    'Dtruit la collection lorsque cette classe est dtruite
    Set mCol = Nothing
End Sub

